UNIT Combined;

INTERFACE

USES
  Crt,
  Utility,
  WriteCFG,
  DOS,
  List2Data,
  List2ADT;

PROCEDURE VersionNumber;
PROCEDURE DirectoryWindow (DirList : ListType; VAR NumInWin : Byte; FileType : STRING);
PROCEDURE DirSelect
  (RegText, RegBack, SelText, SelBack, Startx, StartY, Height : Byte;
   VAR Cursor    : Byte;
   DirList       : ListType;
   VAR CFGName   : STRING);
PROCEDURE GetDirectory (VAR DirList : ListType; FileType : STRING);
PROCEDURE MainSelect (RegText, RegBack, SelText, SelBack, Startx, StartY, Height : byte;
                     VAR Cursor : byte; Menu : MenuType);
PROCEDURE ChangeController (VAR Controller : Byte; VAR CFGName : STRING);
PROCEDURE ChangePlayerName (VAR PlayerName : String10);
PROCEDURE ChangeVidMode (VAR VidMode : Byte);
PROCEDURE ChangeFile (VAR FileName : STRING; FileType : STRING);
PROCEDURE VerifyCFG (VAR ValidGo : Boolean; CFGName : STRING);
PROCEDURE ImportSettings (PlayerName : String10; NumPlayers, VidMode : Byte; CFGName : STRING);
PROCEDURE DefaultSettings (PlayerName : String10; NumPlayers, VidMode, Controller : Byte);
PROCEDURE SaveSettings (PlayerName : String10; NumPlayers, VidMode : Byte; ModeData : STRING);


IMPLEMENTATION

{***************************************************************************}
PROCEDURE VersionNumber;

BEGIN
  TcTb (11,0);
  WrtS (75,23,'ver2.7');
END;

{***************************************************************************}
PROCEDURE DirectoryWindow (DirList : ListType; VAR NumInWin : Byte; FileType : STRING);

VAR
  Count     : Byte;
  MapFile   : ListElementType;
  TempChr   : Char;
  WinSize   : Byte;

BEGIN
  IF FileType = 'a:\*.cfg' THEN
      WinSize := 6
    ELSE WinSize := 12;
  IF FileType = 'a:\*.cfg' THEN
      MakeWin (7,1,40,17,18,WinSize,True,True)
    ELSE MakeWin (7,1,40,11,18,WinSize,True,True);
  TcTb (15,1);
  IF NOT(EmptyList(DirList)) THEN
      BEGIN
        IF ListLength(DirList) >= WinSize - 2 THEN NumInWin := WinSize - 2
          ELSE NumInWin := ListLength(DirList);
        FOR Count := 1 TO NumInWin DO
          BEGIN
            MapFile.Position := Count;
            RetrieveElement (DirList,MapFile);
            WrtS (2,Count,MapFile.FileName);
          END;
      END
    ELSE
      BEGIN
        IF FileType = 'a:\*.cfg' THEN
            WrtS (2,1,'No .CFGs Found')
          ELSE WrtS (2,1,'No .MAPs Found');
        WrtS (2,2,'Press <ENTER>');
        HideCursor (1,1,1);
        REPEAT
          TempChr := readkey
        UNTIL TempChr = #13;
      END;
END;

{***************************************************************************}
PROCEDURE DirSelect
  (RegText, RegBack, SelText, SelBack, Startx, StartY, Height : Byte;
   VAR Cursor    : Byte;
   DirList       : ListType;
   VAR CFGName   : STRING);

VAR
  Choice  : Char;
  Count,
  Top     : Byte;
  MapFile : ListElementType;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE Move
  (Choice     : Char;
   VAR Cursor : Byte);

VAR
  Count : Byte;

BEGIN
  CASE Choice OF
    #72 : IF Cursor > 1 THEN dec(Cursor)
            ELSE IF (Top + Cursor - 1) > 1 THEN dec(Top);
    #80 : IF Cursor < Height THEN inc(Cursor)
            ELSE IF (Top + Cursor - 1) < ListLength(DirList) THEN inc(Top);
    #71 : BEGIN
            Cursor := 1;
            Top := 1;
          END;
    #79 : BEGIN
            Cursor := Height;
            Top := (ListLength(DirList) - Height + 1);
          END;
  END;
  TcTb (RegText, RegBack);
  FOR Count := 1 TO Height DO
    BEGIN
      MapFile.Position := (Count + Top - 1);
      RetrieveElement (DirList,MapFile);
      WrtS (StartX,Count,MapFile.FileName);
    END;
  TcTb (SelText, SelBack);
  MapFile.Position := Cursor + Top - 1;
  RetrieveElement (DirList,MapFile);
  WrtS (StartX, (Cursor + StartY - 1), MapFile.FileName);
END;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN
  TcTb (SelText, SelBack);
  Top := Cursor;
  MapFile.Position := Cursor;
  RetrieveElement (DirList,MapFile);
  WrtS (StartX, (Cursor + StartY - 1), MapFile.FileName);
  Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
  Choice := readkey;
  WHILE NOT(Choice IN [#13,#27]) DO
    BEGIN
      IF Choice IN [#72,#80,#71,#79,#73,#81] THEN Move (Choice,Cursor);
      Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
      Choice := readkey;
    END;
  IF Choice = #13 THEN
    BEGIN
      MapFile.Position := Cursor + Top - 1;
      RetrieveElement (DirList,MapFile);
      delete (MapFile.FileName,1,1);
      count := 0;
      REPEAT
        inc(count);
      UNTIL MapFile.FileName[Count] = '.';
      delete (MapFile.FileName,Count,length(MapFile.FileName) - Count + 1);
      CFGName := '';
      CFGName := MapFile.FileName;
    END;
END;

{***************************************************************************}
PROCEDURE GetDirectory (VAR DirList : ListType; FileType : STRING);

VAR
  DirInfo  : SearchRec;
  NumFiles,
  Count    : Byte;
  MapFile  : ListElementType;

BEGIN
  FindFirst(FileType,Archive,DirInfo);
  NumFiles := 0;
  WHILE (DosError = 0) AND (NumFiles < 255) DO
    BEGIN
      inc(NumFiles);
      MapFile.FileName := ' ' + DirInfo.Name;
      FOR Count := length(MapFile.FileName) TO 13 DO
        MapFile.FileName := MapFile.FileName + ' ';
      InsertElement (DirList,MapFile);
      FindNext(DirInfo);
    END;

  ResetList (DirList);
  FOR Count := 1 TO NumFiles DO
    BEGIN
      GetNextItem (DirList,MapFile);
      DeleteElement (DirList,MapFile);
      MapFile.Position := Count;
      InsertElement (DirList,MapFile);
    END;
END;

{***************************************************************************}
PROCEDURE MainSelect
  (RegText,
   RegBack,
   SelText,
   SelBack,
   Startx,
   StartY,
   Height     : byte;
   VAR Cursor : byte;
   Menu       : MenuType);
  {*     Pre : No selection has been made                        *}
  {*    Post : Selection has been made a cursor position         *}

VAR
  Choice : Char;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE Move
  (Choice : char;
   VAR Cursor : byte);
  {* Purpose : Move the current position up or down by choice    *}
  {*     Pre : Cursor is at old postion                          *}
  {*    Post : Cursor is at new postion                          *}

BEGIN {* Move *}

  {* Draw over the old arrows *}
  TcTb (RegText, RegBack);
  WrtS (StartX, (Cursor + StartY - 1), Menu[Cursor]);

  {* Update postion *}
  CASE Choice OF
    #72 : IF Cursor = 1
            THEN Cursor := Height
            ELSE dec(Cursor);
    #80 : IF Cursor = Height
            THEN Cursor := 1
            ELSE inc(Cursor);
  END; {* CASE *}

  {* Draw new arrows *}
  TcTb (SelText, SelBack);
  WrtS (StartX, (Cursor + StartY - 1), Menu[Cursor]);

END; {* Move *}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN {* Select *}

  {* Draw starting arrows *}
  TcTb (SelText, SelBack);
  WrtS (StartX, (Cursor + StartY - 1), Menu[Cursor]);
  Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
  Choice := readkey;

  {* Read choice and make adjustments *}
  WHILE NOT(Choice IN[#13,#15]) DO
    BEGIN {* WHILE *}
      Move (Choice,Cursor);
      Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
      Choice := readkey;
    END; {* WHILE *}

  IF Choice = #15 THEN Cursor := 255;
END; {* Select *}

{***************************************************************************}
PROCEDURE ChangeFile
  (VAR FileName : STRING; FileType : STRING);

VAR
  NumInWin,
  Cursor  : Byte;
  DirList : ListType;

BEGIN
  CreateList (DirList);
  GetDirectory (DirList,FileType);
  DirectoryWindow (DirList,NumInWin,FileType);
  IF NOT(EmptyList(DirList)) THEN
      BEGIN
        Cursor := 1;
        DirSelect (15,1,0,7,2,1,NumInWin,Cursor,DirList,FileName);
      END
   ELSE
     IF FileType = 'a:\*.cfg' THEN
         FileName := 'NONFOUND'
       ELSE FileName := 'NONE';
  DestroyList (DirList);
END;

{***************************************************************************}
PROCEDURE CheckAgain
  (    CheckWhat : STRING;
   VAR Cancel    : Boolean;
       CFGName   : STRING);

VAR
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Menu[1] := ' Retry ';
  Menu[2] := ' Cancel ';
  Beep (600,300);
  MakeWin (7,1,31,5,44,10,True,True);
  TcTb (12,1);
  WrtS (13,1,CheckWhat);
  WrtS (21,1,CFGName + '.CFG!');
  TcTb (15,1);
  WrtS (2,2,'Please make sure your disk with the file');
  WrtS (2,3,'named ' + CFGName + '.CFG is in in the A: drive');
  WrtS (2,4,'and that it is a valid CFG file.');
  MakeWin (11,1,46,10,12,4,True,False);
  TcTb (15,1);
  WrtS (2,1,Menu[1]);
  WrtS (2,2,Menu[2]);
  Cursor := 1;
  Select (15,1,0,7,2,1,2,Cursor,Menu);
  IF Cursor = 2 THEN Cancel := True;
END;

{***************************************************************************}
PROCEDURE VerifyCFG
  (VAR ValidGo : Boolean;
       CFGName : STRING);

VAR
  Cursor   : Byte;
  Cancel   : Boolean;
  TempFile : Text;
  TempStr  : STRING;

BEGIN
  ValidGo := False;
  Cancel := False;
  REPEAT
    TempStr := fsearch ('A:\' + CFGName + '.CFG',getenv('PATH'));
    IF TempStr = '' THEN CheckAgain ('Missing',Cancel,CFGName);
    IF (TempStr <> '') AND NOT(Cancel) THEN
      BEGIN
        assign (TempFile, 'a:\' + CFGName + '.cfg');
        reset (TempFile);
        REPEAT
          readln (TempFile,TempStr);
        UNTIL (TempStr = '[KeyDefinitions]') OR EoF(TempFile);
        close (TempFile);
        IF TempStr <> '[KeyDefinitions]' THEN CheckAgain ('Invalid',Cancel,CFGName)
          ELSE ValidGo := True;
      END;
  UNTIL ValidGo OR Cancel;
  IF Cancel THEN ValidGo := False;
END;

{***************************************************************************}
PROCEDURE DefaultSettings
  (PlayerName  : String10;
   NumPlayers,
   VidMode,
   Controller  : Byte);

VAR
  NewCFG : Text;

BEGIN
  assign (NewCfg, 'duke3d.cfg');
  rewrite (NewCfg);
  ScreenSettings (NewCFG,VidMode);
  DefaultControllers (NewCFG,Controller);
  CommSettings (NewCFG,PlayerName,NumPlayers);
  CommitDat (NumPlayers);
  close (NewCfg);
END;

{***************************************************************************}
PROCEDURE ImportSettings
  (PlayerName : String10;
   NumPlayers,
   VidMode    : Byte;
   CFGName    : STRING);

VAR
  TempStr   : STRING;
  ImportCFG,
  NewCFG    : Text;

BEGIN
  assign (NewCfg, 'duke3d.cfg');
  assign (ImportCfg, 'a:\' + CFGName + '.cfg');
  rewrite (NewCfg);
  reset (ImportCfg);
  ScreenSettings (NewCFG,VidMode);
  REPEAT
    readln (ImportCfg,TempStr);
  UNTIL (TempStr = '[KeyDefinitions]');
  REPEAT
    writeln (NewCfg,TempStr);
    Readln (ImportCfg,TempStr);
  UNTIL TempStr = '[Comm Setup]';
  CommSettings (NewCFG,PlayerName,NumPlayers);
  CommitDat (NumPlayers);
  close (NewCfg);
  close (ImportCfg);
END;

{***************************************************************************}
PROCEDURE ChangeVidMode
  (VAR VidMode : Byte);

VAR
  Count : Byte;
  Menu  : MenuType;

BEGIN
  Menu[1] := ' 320x200 ';
  Menu[2] := ' 320x240 ';
  Menu[3] := ' 320x400 ';
  Menu[4] := ' 360x200 ';
  Menu[5] := ' 360x240 ';
  Menu[6] := ' 640x350 ';
  Menu[7] := ' 640x400 ';
  Menu[8] := ' 640x480 ';
  MakeWin (7,1,31,5,13,10,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 8 DO
    WrtS (2,Count,Menu[Count]);
  Select (15,1,0,7,2,1,8,VidMode,Menu);
END;

{***************************************************************************}
PROCEDURE ChangePlayerName
  (VAR PlayerName : String10);

VAR
  Charac : Char;
  Count  : Byte;
  Exit   : Boolean;

BEGIN
  MakeWin (7,1,31,5,26,4,True,True);
  TcTb (15,1);
  WrtS (2,1,'Enter your screen name');
  WrtS (2,2,'==> ');
  TcTb (15,3);
  FOR Count := 1 TO 10 + 2 DO write (' ');
  gotoXY (7,2);
  FOR Count := 1 TO 10 DO PlayerName[Count] := ' ';
  Exit := False;
  Count := 0;
  WHILE NOT Exit DO
     BEGIN
       Charac := Readkey;
       IF (Charac IN [#33..#126,' ']) AND (Count IN [0..9]) THEN
           BEGIN
             inc(Count);
             PlayerName[Count] := Charac;
             WrtS (Count + 6,2,PlayerName[Count]);
             IF Count = 10 THEN GotoXY (Count + 6,2);
           END
         ELSE
           IF (Charac = #8) AND (Count >= 1) THEN
               BEGIN
                 PlayerName[Count] := ' ';
                 WrtS (Count + 6,2,PlayerName[Count]);
                 GotoXY (Count + 6,2);
                 dec(Count);
               END
             ELSE
               IF (Charac = #13) THEN
                   Exit := True
                 ELSE
                   IF (Charac = #0) THEN
                     ELSE Beep (700,50);
     END;
END;

{***************************************************************************}
PROCEDURE ChangeController
  (VAR Controller : Byte; VAR CFGName : STRING);

VAR
  Count : Byte;
  Menu  : MenuType;

BEGIN
  Menu[1] := ' Custom Configuration (A:\?.CFG) ';
  Menu[2] := ' Keyboard Only ';
  Menu[3] := ' Keyboard & Mouse ';
  Menu[4] := ' Keyboard & Joystick ';
  Menu[5] := ' Keyboard & Gamepad ';
  Menu[6] := ' Keyboard & FlightStick ';
  Menu[7] := ' Keyboard & Thrustmaster/Wingman ';
  Menu[8] := ' Keyboard & External ';
  MakeWin (7,1,31,5,37,10,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 8 DO
    WrtS (2,Count,Menu[Count]);
  Count := Controller;
  Select (15,1,0,7,2,1,8,Controller,Menu);
  IF Controller = 1 THEN ChangeFile (CFGName,'a:\*.cfg');
  IF CFGName = 'NONFOUND' THEN
    BEGIN
      Controller := Count;
      CFGName := 'DUKE3D';
    END;
END;

{***************************************************************************}
PROCEDURE SaveSettings
  (PlayerName : String10;
   NumPlayers,
   VidMode    : Byte;
   ModeData   : STRING);

VAR
  Settings : Text;

BEGIN
  assign (Settings, ModeData);
  rewrite (Settings);
  writeln (Settings, PlayerName);
  writeln (Settings, NumPlayers);
  writeln (Settings, VidMode);
  close (Settings);
END;

{***************************************************************************}

END.