UNIT RegularMode;

INTERFACE

USES
  Crt,
  Dos,
  Utility,
  WriteCFG,
  Combined;

PROCEDURE Regular;

IMPLEMENTATION

{***************************************************************************}
PROCEDURE Initialize
  (VAR Menu        : MenuType;
   VAR PlayerName  : String10;
   VAR NumPlayers,
       Controller,
       VidMode,
       Cursor      : Byte;
   VAR Exit,
       DoMap       : Boolean;
   VAR CFGName,
       MapName     : STRING;
       ModeData    : STRING);

VAR
  Settings : Text;

BEGIN
  Menu[1] := ' Controller Setting ';
  Menu[2] := ' Player Screen Name ';
  Menu[3] := ' Video Resolution ';
  Menu[4] := ' Number of Players ';
  Menu[5] := ' Play User .MAP ';
  Menu[6] := ' Start Playing ';
  Menu[7] := ' Exit The Shootout ';
  Assign (Settings, ModeData);
  reset (Settings);
  readln (Settings, PlayerName);
  readln (Settings, NumPlayers);
  readln (Settings, VidMode);
  close (Settings);
  Controller := 3;
  Cursor := 1;
  Exit := False;
  DoMap := False;
  CFGName := 'DUKE3D';
  MapName := 'NONE';
END;

{***************************************************************************}
PROCEDURE ChangeNumPlayers
  (VAR NumPlayers : Byte);

VAR
  Count : Byte;
  Menu  : MenuType;

BEGIN
  Menu[1] := ' Single Player ';
  Menu[2] := ' 2 player network ';
  Menu[3] := ' 3 player network ';
  Menu[4] := ' 4 player network ';
  Menu[5] := ' 5 player network ';
  Menu[6] := ' 6 player network ';
  Menu[7] := ' 7 player network ';
  Menu[8] := ' 8 player network ';
  MakeWin (7,1,31,5,22,10,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 8 DO WrtS (2,Count,Menu[Count]);
  Select (15,1,0,7,2,1,8,NumPlayers,Menu);
END;

{***************************************************************************}
PROCEDURE MainScreenSetup
  (Menu        : MenuType;
   PlayerName  : String10;
   NumPlayers,
   VidMode,
   Controller  : Byte;
   CFGName,
   MapName     : STRING);

VAR
  Count : Byte;

BEGIN
  Clear (0,7,1,1,80,1);
  WrtS (2,1,'Shootout Launcher by Charlie Wiederhold');
  WrtS (55,1,'(c) 1996 Rodeo Steakhouse');
  Window (1,2,80,25);
  TcTb (8,0);
  Window (1,2,80,25);
  FOR Count := 2 TO 24 DO
    WrtS (1,Count,'');
  VersionNumber;
  Clear (0,7,1,25,80,25);
  TcTb (4,7);
  WrtS (4,1,'<SHIFT><TAB>');
  TcTb (0,7);
  WrtS (16,1,'=Setup.exe');
  WrtS (30,1,'Welcome to The Rodeo Steakhouse and CyberRodeo');
  TcTb (5,7);
  WrtC (28,1,#9);
  WrtC (77,1,#9);
  MakeWin (7,1,3,4,24,17,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 7 DO
    WrtS (2,Count,Menu[Count]);
  TcTb (11,1);
  WrtS (4,9,'Current Settings');
  TcTb (15,1);
  WrtS (2,11,'Controller:');
  WrtS (2,12,'Player:');
  WrtS (2,13,'Video Mode:');
  WrtS (2,14,'Number of Players:');
  WrtS (2,15,'Play .MAP:');
  TcTb (14,1);
  CASE Controller OF
    1 : WrtS (14,11,CFGName);
    2 : WrtS (14,11,'Keyboard');
    3 : WrtS (14,11,'Kb/Mouse');
    4 : WrtS (14,11,'Kb/Jystk');
    5 : WrtS (14,11,'Kb/Gmpad');
    6 : WrtS (14,11,'Kb/Flstk');
    7 : WrtS (14,11,'Kb/TM/WM');
    8 : WrtS (14,11,'Kb/Extnl');
  END;
  WrtS (10,12,PlayerName);
  CASE VidMode OF
    1 : WrtS (14,13,'320x200');
    2 : WrtS (14,13,'320x240');
    3 : WrtS (14,13,'320x400');
    4 : WrtS (14,13,'360x200');
    5 : WrtS (14,13,'360x240');
    6 : WrtS (14,13,'640x350');
    7 : WrtS (14,13,'640x400');
    8 : WrtS (14,13,'640x480');
  END;
  WrtI (21,14,NumPlayers);
  WrtS (13,15,MapName);
  window (3,12,27,14);
  TcTb (7,1);
  WrtC (1,1,'');
  WrtC (24,1,'');
  FOR Count := 2 TO 23 DO
    WrtC (Count,1,'');
  WrtC (1,3,'');
  WrtC (24,3,'');
  FOR Count := 2 TO 23 DO
    WrtC (Count,3,'');
  window (4,5,25,18);
END;

{***************************************************************************}
PROCEDURE UseMap (VAR DoMap : Boolean; VAR MapName : STRING);

BEGIN
  MakeWin (7,1,31,4,42,5,True,True);
  TcTb (15,1);
  WrtS (2,1,'Select the .MAP file you would like to');
  WrtS (2,2,'play. If you are playing a multiplayer');
  WrtS (2,3,'game you must all select the same .MAP');
  MakeWin (7,1,40,11,17,4,True,True);
  TcTb (15,1);
  WrtS (2,1,'Loading......');
  TcTb (30,1);
  WrtS (3,2,'Please wait');
  HideCursor (1,1,1);
  ChangeFile (MapName,'c:*.map');
  IF MapName <> 'NONE' THEN
      DoMap := True
    ELSE DoMap := False;
END;

{***************************************************************************}
PROCEDURE Regular;

VAR
  Controller,
  VidMode,
  NumPlayers,
  Cursor      : Byte;
  Menu        : MenuType;
  Exit,
  DoMap,
  ValidGo     : Boolean;
  MapName,
  CFGName     : STRING;
  PlayerName  : String10;

BEGIN
  REPEAT
    Initialize (Menu,PlayerName,NumPlayers,Controller,VidMode,Cursor,DoMap,Exit,
                CFGName,MapName,'regular.dat');
    REPEAT
      MainScreenSetup (Menu,PlayerName,NumPlayers,VidMode,Controller,CFGName,MapName);
      MainSelect (15,1,0,7,2,1,7,Cursor,Menu);
      CASE Cursor OF
        1 : ChangeController (Controller,CFGName);
        2 : ChangePlayerName (PlayerName);
        3 : ChangeVidMode (VidMode);
        4 : ChangeNumPlayers (NumPlayers);
        5 : UseMap (DoMap,MapName);
        7 : Exit := TRUE;
      END;
    UNTIL (Cursor IN [6,255]) OR Exit;
    SaveSettings (PlayerName,NumPlayers,VidMode,'regular.dat');
    IF Cursor = 6 THEN
      BEGIN
        ValidGo := True;
        IF Controller = 1 THEN
            BEGIN
              VerifyCFG (ValidGo,CFGName);
              IF ValidGo THEN ImportSettings (PlayerName,NumPlayers,VidMode,CFGName);
            END
          ELSE DefaultSettings (PlayerName,NumPlayers,VidMode,Controller);
        IF ValidGo THEN
          BEGIN
            Clear (7,0,1,1,80,25);
            IF DoMap THEN
                IF NumPlayers = 1 THEN exec ('c:duke3d.exe','-MAP ' + MapName + '.MAP')
                  ELSE exec ('c:commit.exe','-MAP ' + MapName + '.MAP')
              ELSE
                IF NumPlayers = 1 THEN exec ('c:duke3d.exe','')
                  ELSE exec ('c:commit.exe','');

          END;
      END;
    IF Cursor = 255 THEN
      BEGIN
        Exit := True;
        Clear (7,0,1,1,80,25);
        exec ('c:setup.exe','');
      END;
  UNTIL Exit;
END;

{***************************************************************************}

END.