UNIT TournamentMode;

INTERFACE

USES
  Crt,
  Dos,
  Utility,
  WriteCFG,
  Combined;

PROCEDURE Tournament;

IMPLEMENTATION

{***************************************************************************}
PROCEDURE Initialize
  (VAR Menu        : MenuType;
   VAR PlayerName  : String10;
   VAR NumPlayers,
       Controller,
       VidMode,
       Cursor      : Byte;
   VAR Exit        : Boolean;
   VAR CFGName     : STRING;
       ModeData    : STRING);

VAR
  Settings : Text;

BEGIN
  Menu[1] := ' Controller Setting ';
  Menu[2] := ' Player Screen Name ';
  Menu[3] := ' Video Resolution ';
  Menu[4] := ' Number of Players ';
  Menu[5] := ' Start Playing ';
  Menu[6] := ' Exit The Shootout ';
  Assign (Settings, ModeData);
  reset (Settings);
  readln (Settings, PlayerName);
  readln (Settings, NumPlayers);
  readln (Settings, VidMode);
  close (Settings);
  Controller := 3;
  Cursor := 1;
  Exit := False;
  CFGName := 'DUKE3D'
END;

{***************************************************************************}
PROCEDURE ChangeNumPlayers
  (VAR NumPlayers : Byte);

VAR
  Count : Byte;
  Menu  : MenuType;

BEGIN
  Menu[1] := ' 2 player round ';
  Menu[2] := ' 3 player round ';
  Menu[3] := ' 4 player round ';
  Menu[4] := ' 5 player round ';
  Menu[5] := ' 6 player round ';
  Menu[6] := ' 7 player round ';
  Menu[7] := ' 8 player round ';
  MakeWin (7,1,31,5,20,9,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 7 DO WrtS (2,Count,Menu[Count]);
  dec(NumPlayers);
  Select (15,1,0,7,2,1,7,NumPlayers,Menu);
  inc(NumPlayers);
END;

{***************************************************************************}
PROCEDURE MainScreenSetup
  (Menu        : MenuType;
   PlayerName  : String10;
   NumPlayers,
   VidMode,
   Controller  : Byte;
   CFGName     : STRING);

VAR
  Year,
  Month,
  Day,
  DayOWeek : Word;
  Count    : Byte;

BEGIN
  Clear (0,7,1,1,80,1);
  WrtS (2,1,'Shootout Launcher by Charlie Wiederhold');
  WrtS (55,1,'(c) 1996 Rodeo Steakhouse');
  Window (1,2,80,25);
  TcTb (8,0);
  Window (1,2,80,25);
  FOR Count := 2 TO 24 DO
    WrtS (1,Count,'');
  VersionNumber;
  Clear (0,7,1,25,80,25);
  WrtS (8,1,'Welcome to The Duke Nukem 3D Rodeo Shootout - ');
  GetDate(Year,Month,Day,DayOWeek);
  CASE Month OF
     1 : write ('January ', Day, ', ', Year);
     2 : write ('Febuary ', Day, ', ', Year);
     3 : write ('March ', Day, ', ', Year);
     4 : write ('April ', Day, ', ', Year);
     5 : write ('May ', Day, ', ', Year);
     6 : write ('June ', Day, ', ', Year);
     7 : write ('July ', Day, ', ', Year);
     8 : write ('August ', Day, ', ', Year);
     9 : write ('September ', Day, ', ', Year);
    10 : write ('October ', Day, ', ', Year);
    11 : write ('November ', Day, ', ', Year);
    12 : write ('December ', Day, ', ', Year);
  END;
  MakeWin (7,1,3,5,24,15,True,True);
  TcTb (15,1);
  FOR Count := 1 TO 6 DO
    WrtS (2,Count,Menu[Count]);
  TcTb (11,1);
  WrtS (4,8,'Current Settings');
  TcTb (15,1);
  WrtS (2,10,'Controller:');
  WrtS (2,11,'Player:');
  WrtS (2,12,'Video Mode:');
  WrtS (2,13,'Number of Players:');
  TcTb (14,1);
  CASE Controller OF
    1 : WrtS (14,10,CFGName);
    2 : WrtS (14,10,'Keyboard');
    3 : WrtS (14,10,'Kb/Mouse');
    4 : WrtS (14,10,'Kb/Jystk');
    5 : WrtS (14,10,'Kb/Gmpad');
    6 : WrtS (14,10,'Kb/Flstk');
    7 : WrtS (14,10,'Kb/TM/WM');
    8 : WrtS (14,10,'Kb/Extnl');
  END;
  WrtS (10,11,PlayerName);
  CASE VidMode OF
    1 : WrtS (14,12,'320x200');
    2 : WrtS (14,12,'320x240');
    3 : WrtS (14,12,'320x400');
    4 : WrtS (14,12,'360x200');
    5 : WrtS (14,12,'360x240');
    6 : WrtS (14,12,'640x350');
    7 : WrtS (14,12,'640x400');
    8 : WrtS (14,12,'640x480');
  END;
  WrtI (21,13,NumPlayers);
  window (3,12,27,14);
  TcTb (7,1);
  WrtC (1,1,'');
  WrtC (24,1,'');
  FOR Count := 2 TO 23 DO
    WrtC (Count,1,'');
  WrtC (1,3,'');
  WrtC (24,3,'');
  FOR Count := 2 TO 23 DO
    WrtC (Count,3,'');
  window (4,6,25,18);
END;

{***************************************************************************}
PROCEDURE Tournament;

VAR
  Controller,
  VidMode,
  NumPlayers,
  Cursor      : Byte;
  Menu        : MenuType;
  Exit,
  ValidGo     : Boolean;
  CFGName     : STRING;
  PlayerName  : String10;

BEGIN
  REPEAT
    Initialize (Menu,PlayerName,NumPlayers,Controller,VidMode,Cursor,Exit,CFGName,'tourny.dat');
    REPEAT
      MainScreenSetup (Menu,PlayerName,NumPlayers,VidMode,Controller,CFGName);
      MainSelect (15,1,0,7,2,1,6,Cursor,Menu);
      CASE Cursor OF
        1 : ChangeController (Controller,CFGName);
        2 : ChangePlayerName (PlayerName);
        3 : ChangeVidMode (VidMode);
        4 : ChangeNumPlayers (NumPlayers);
        6 : Exit := TRUE;
      END;
    UNTIL (Cursor IN [5,255]) OR Exit;
    SaveSettings (PlayerName,NumPlayers,VidMode,'tourny.dat');
    IF Cursor = 5 THEN
      BEGIN
        ValidGo := True;
        IF Controller = 1 THEN
            BEGIN
              VerifyCFG (ValidGo,CFGName);
              IF ValidGo THEN ImportSettings (PlayerName,NumPlayers,VidMode,CFGName);
            END
          ELSE DefaultSettings (PlayerName,NumPlayers,VidMode,Controller);
        IF ValidGo THEN
          BEGIN
            Clear (7,0,1,1,80,25);
            IF NumPlayers = 1 THEN exec ('c:duke3d.exe','')
              ELSE exec ('c:commit.exe','');
          END;
      END;
    IF Cursor = 255 THEN
      BEGIN
        Exit := True;
        Clear (7,0,1,1,80,25);
        exec ('c:setup.exe','');
      END;
  UNTIL Exit;
END;

{***************************************************************************}

END.