{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT Utility; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************
 *                                                                         *
 *   Author     : Charlie Wiederhold                                       *
 *   Date       : February 22, 1996                                        *
 *   SSN        : 459-89-8302                                              *
 *   TA         : Gooty                                                    *
 *   TA Section : Wed. 3:00 - 4:00                                         *
 *   Assignment : Program 2 - Stack appliction                             *
 *                                                                         *
 ***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


USES
  Crt;                       {* Used for basic screen actions *}

CONST
  MaxMenu  = 8;

TYPE
  MenuType = ARRAY [1..MaxMenu] OF STRING;

{***************************************************************************}
FUNCTION  Convert
  (Strng : STRING;
   VAR Int : Integer) : Boolean;
  {* Purpose : Convert a string to integer, if possible        *}
  {*     Pre : String value to be changed                      *}
  {*    Post : Converted to integer or false funtion           *}

{***************************************************************************}
FUNCTION  ConvertReal
  (Strng : STRING;
   VAR Reel : Real): Boolean;
  {* Purpose : Convert a string to real, if possible           *}
  {*     Pre : String value to be changed                      *}
  {*    Post : Converted to real or false function             *}

{***************************************************************************}
PROCEDURE Beep
  (Pitch,
   Time : Integer);
  {* Purpose : Creates a sound for error essages to be noticable *}
  {*    Post : Sound has been created                            *}

{***************************************************************************}
PROCEDURE TcTb
  (Tc,
   Tb : byte);
  {* Purpose : Combines the textcolor textbackground commands    *}
  {*    Post : Textcolor and background have been declared       *}

{***************************************************************************}
PROCEDURE WrtC
  (X,
   Y : byte;
   Chr : char);
  {* Purpose : Write a character at designated postion           *}
  {*    Post : Character has been written                        *}

{***************************************************************************}
PROCEDURE WrtS
  (X,
   Y : byte; Str : STRING);
  {* Purpose : Write a string at a designated position           *}
  {*    Post : String has been written                           *}

{***************************************************************************}
PROCEDURE WrtI
  (X,
   Y : byte;
   Int : integer);
  {* Purpose : Write an integer at a designated position         *}
  {*    Post : Integer has been written                          *}

{***************************************************************************}
PROCEDURE WrtR
  (X,
   Y : byte;
   Reel : real;
   Field,
   Decimal : byte);
  {* Purpose : Write a real number at designated postion         *}
  {*    Post : Real has been written with designated fields      *}

{***************************************************************************}
PROCEDURE FrmtI
  (X,
   Y : byte;
   Int : integer;
   Field : byte);
  {* Purpose : Writes an integer at designated positon           *}
  {*    Post : Integer has been written with proper format       *}

{***************************************************************************}
PROCEDURE Clear
  (Text,
   Backcolor,
   Ulx,
   Uly,
   Lrx,
   Lry : byte);
  {* Purpose : Clear a section of screen with designated colors  *}
  {*    Post : Section has been cleared                          *}

{***************************************************************************}
PROCEDURE Hidecursor
  (X,
   Y,
   Color : byte);
  {* Purpose : Hide the cursor at designated postion and color   *}
  {*    Post : Cursor has been hidden                            *}

{***************************************************************************}
PROCEDURE MakeWin
  (TC,
   BC,
   Ulx,
   Uly,
   Width,
   Height : byte;
   Border,
   Shadow : Boolean);

  {* Purpose : To create a window with border and shadow         *}
  {*     Pre : No window has been created                        *}
  {*    Post : The specified window has been created             *}

{***************************************************************************}
PROCEDURE Select
  (RegText,
   RegBack,
   SelText,
   SelBack,
   Startx,
   StartY,
   Height     : byte;
   VAR Cursor : byte;
   Menu       : MenuType);
  {* Purpose : Allows a menu to be used to select options        *}
  {*     Pre : No selection has been made                        *}
  {*    Post : Selection has been made a cursor position         *}

{***************************************************************************}
PROCEDURE ReadString
  (WhereX,
   WhereY : Integer;
   VAR Strng : STRING;
   Prompt : STRING);
  {* Purpose : Reads a string and pass it back to call         *}
  {*    Post : String read and data passed back to call        *}

{***************************************************************************}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{**************************************************************************}
FUNCTION Convert
  (Strng : STRING;
   VAR Int : Integer) : Boolean;
  {*     Pre : String value to be changed                      *}
  {*    Post : Converted to integer or false funtion           *}

VAR
  ErrorPos : Integer;  {* Error position *}

BEGIN {* Convert *}
  val(Strng, Int, ErrorPos);
  IF ErrorPos = 0 THEN
      Convert := True
    ELSE Convert := False;
END; {* Convert *}

{**************************************************************************}
FUNCTION ConvertReal
  (Strng : STRING;
   VAR Reel : Real) : Boolean;
  {*     Pre : String value to be changed                      *}
  {*    Post : Converted to real or false function             *}

VAR
  WholeStr,              {* Temp string for dollar amount *}
  DecimalStr : STRING;   {* Temp string for cent amoutn   *}
  Whole,                 {* Dollars in the price          *}
  Decimal    : Integer;  {* Cents in the price            *}
  Long,                  {* Length of the string price    *}
  ErrorPos,              {* Error position                *}
  DecimalPos : Byte;     {* Decimal position              *}

BEGIN {* ConvertReal *}

  {* Break string into dollars and cents *}
  WholeStr := Strng;
  DecimalStr := Strng;
  Long := Length (Strng);
  DecimalPos := pos ('.',Strng);
  IF DecimalPos <> 0 THEN
      BEGIN
        Delete (WholeStr,DecimalPos,Long);
        Delete (DecimalStr,1,DecimalPos);
      END
    ELSE
      BEGIN
        WholeStr := Strng;
        DecimalStr := '00';
      END;

  {* Convert dollars and cents, if possible *}
  IF NOT (Convert (WholeStr,Whole) AND Convert (DecimalStr,Decimal)) THEN
      ConvertReal := False
    ELSE
      BEGIN
        Reel := (Whole + Decimal/100);
        ConvertReal := True;
      END;

END; {* ConvertReal *}

{***************************************************************************}
PROCEDURE Beep
  (Pitch,
   Time : Integer);
  {*    Post : Sound has been created                            *}

BEGIN {* Beep *}
  Sound (Pitch);
  Delay (Time);
  Nosound;
END; {* Beep *}

{***************************************************************************}
PROCEDURE TcTb
  (Tc,
   Tb : byte);
  {*    Post : Textcolor and background have been declared       *}

BEGIN {* TcTb *}
  textcolor (Tc);
  textbackground (Tb);
END; {* TcTb *}

{***************************************************************************}
PROCEDURE WrtC
  (X,
   Y : byte;
   Chr: char);
  {*    Post : Character has been written                        *}

BEGIN {* WrtC *}
  gotoXY (X, Y);
  write (Chr);
END; {* WrtC *}

{***************************************************************************}
PROCEDURE WrtS
  (X,
   Y : byte;
   Str : STRING);
  {*    Post : String has been written                           *}

BEGIN {* WrtS *}
  gotoXY (X, Y);
  write (Str);
END; {* WrtS *}

{***************************************************************************}
PROCEDURE WrtI
  (X,
   Y : byte;
   Int : integer);
  {*    Post : Integer has been written                          *}

BEGIN {* WrtI *}
  gotoXY (x, y);
  write (int);
END; {* WrtI *}

{***************************************************************************}
PROCEDURE WrtR
  (X,
   Y : byte;
   Reel : real;
   Field,
   Decimal : byte);
  {*    Post : Real has been written with designated fields      *}

BEGIN {* WrtR *}
  gotoXY (X, Y);
  write (Reel:Field:Decimal);
END; {* WrtR *}

{***************************************************************************}
PROCEDURE FrmtI
  (X,
   Y : byte;
   Int: integer;
   Field : byte);
  {*    Post : Integer has been written with proper format       *}

BEGIN {* FrmtI *}
  gotoXY (X,Y);
  write (Int:Field);
END; {* FrmtI *}

{***************************************************************************}
PROCEDURE Clear
  (Text,
   Backcolor,
   Ulx,
   Uly,
   Lrx,
   Lry : byte);
  {*    Post : Section has been cleared                          *}

BEGIN {* Clear *}
  TcTb (Text, Backcolor);
  window (Ulx,Uly,Lrx,Lry);
  clrscr;
END; {* Clear *}

{***************************************************************************}
PROCEDURE Hidecursor
  (X,
   Y,
   Color : byte);
  {*    Post : Cursor has been hidden                            *}

BEGIN {* HideCursor *}
  TcTb (Color, Color);
  WrtC (X, Y, ' ');
  gotoXY (X,Y);
END; {* HideCursor *}

{***************************************************************************}
PROCEDURE MakeWin
  (TC,
   BC,
   Ulx,
   Uly,
   Width,
   Height : byte;
   Border,
   Shadow : Boolean);
  {*     Pre : No window has been created                        *}
  {*    Post : The specified window has been created             *}

CONST
  Vertical    = #186;    {* Vertical character bar line   *}
  Horizontal  = #205;    {* Horizontal character bar line *}
  TopLeft     = #201;    {* Upper left character corner   *}
  TopRight    = #187;    {* Upper right character corner  *}
  BottomLeft  = #200;    {* Bottom left character corner  *}
  BottomRight = #188;    {* Bottom right character corner *}

VAR
  Count : byte;          {* Loop counter control          *}

BEGIN {* MakeWin *}

  {* Clear shadow and main window boxes *}
  window (1,1,80,25);;
  IF Shadow THEN
      Clear (0, 0, (Ulx + 2), (Uly + 1),(Ulx + (Width + 1)), (Uly + Height));
  Clear (TC, BC, Ulx, Uly, Ulx + (Width - 1), Uly + (Height - 1));
  window (1,1,80,25);;


  IF Border THEN
      BEGIN
        {* Draw borders *}
        FOR Count := (Ulx + 1) TO (Ulx + Width - 2) DO
          BEGIN {* For *}
            WrtC (Count, Uly, Horizontal);
            WrtC (Count, (Uly + Height - 1), Horizontal);
          END; {* For *}
        FOR Count := (Uly + 1) TO (Uly + Height - 2) DO
          BEGIN {* For *}
           WrtC (Ulx, Count, Vertical);
           WrtC ((Ulx + Width - 1), Count, Vertical);
          END; {* For *}

        {* Draw corners on the border *}
        WrtC (Ulx, Uly, Topleft);
        WrtC ((Ulx + Width - 1), Uly, TopRight);
        WrtC (Ulx, (Uly + Height - 1), BottomLeft);
        WrtC ((Ulx + Width - 1), (Uly + Height - 1), BottomRight);
      END;

  {* Reset for use within the created window *}
  window (Ulx + 1, Uly + 1, (Ulx + Width - 2), (Uly  + Height - 2));
  TcTb (TC,BC);

END; {* MakeWin *}

{***************************************************************************}
PROCEDURE Select
  (RegText,
   RegBack,
   SelText,
   SelBack,
   Startx,
   StartY,
   Height     : byte;
   VAR Cursor : byte;
   Menu       : MenuType);
  {*     Pre : No selection has been made                        *}
  {*    Post : Selection has been made a cursor position         *}

VAR
  Choice : Char;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE Move
  (Choice : char;
   VAR Cursor : byte);
  {* Purpose : Move the current position up or down by choice    *}
  {*     Pre : Cursor is at old postion                          *}
  {*    Post : Cursor is at new postion                          *}

BEGIN {* Move *}

  {* Draw over the old arrows *}
  TcTb (RegText, RegBack);
  WrtS (StartX, (Cursor + StartY - 1), Menu[Cursor]);

  {* Update postion *}
  CASE Choice OF
    #72 : IF Cursor = 1
            THEN Cursor := Height
            ELSE dec(Cursor);
    #80 : IF Cursor = Height
            THEN Cursor := 1
            ELSE inc(Cursor);
  END; {* CASE *}

  {* Draw new arrows *}
  TcTb (SelText, SelBack);
  WrtS (StartX, (Cursor + StartY - 1), Menu[Cursor]);

END; {* Move *}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

BEGIN {* Select *}

  {* Draw starting arrows *}
  TcTb (SelText, SelBack);
  WrtS (StartX, (Cursor + StartY - 1), Menu[Cursor]);
  Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
  Choice := readkey;

  {* Read choice and make adjustments *}
  WHILE (Choice <> #13) DO
    BEGIN {* WHILE *}
      Move (Choice,Cursor);
      Hidecursor (StartX, (Cursor + StartY - 1), SelBack);
      Choice := readkey;
    END; {* WHILE *}

END; {* Select *}

{**************************************************************************}
PROCEDURE ReadString
  (WhereX,
   WhereY : Integer;
   VAR Strng : STRING;
   Prompt : STRING);
  {*    Post : String read and data passed back to call        *}

BEGIN {* ReadString *}
  WrtS (WhereX,WhereY,Prompt);
  readln (Strng);
END; {* ReadString *}

{***************************************************************************}

END. {* Utility *}