UNIT WriteCFG;

INTERFACE

TYPE
  String8  = STRING[8];
  String10 = STRING[10];

PROCEDURE CommitDat (NumPlayers : Byte);
PROCEDURE DefaultControllers (VAR NewCFG : Text; Controller : Byte);
PROCEDURE ScreenSettings (VAR NewCFG : Text; VidMode : Byte);
PROCEDURE CommSettings (VAR NewCFG : Text; PlayerName : String10; NumPlayers : Byte);

IMPLEMENTATION

{***************************************************************************}
PROCEDURE CommitDat (NumPlayers : Byte);

VAR
  Commit : Text;

BEGIN

  assign (Commit, 'commit.dat');
  rewrite (Commit);
  writeln (Commit, '[Commit]');
  writeln (Commit, ';COMMIT data file');
  writeln (Commit, ';');
  writeln (Commit, ';This data file defines the configurable options of COMMIT.  Presumably,');
  writeln (Commit, ';the user never sees this file, but rather it is setup by another');
  writeln (Commit, ';program which launches COMMIT.');
  writeln (Commit, ';');
  writeln (Commit, ';');
  writeln (Commit, ';COMMTYPE');
  writeln (Commit, '; - SERIAL - 1');
  writeln (Commit, '; - MODEM - 2');
  writeln (Commit, '; - NETWORK - 3');
  writeln (Commit, ';');
  writeln (Commit, '; NUMPLAYERS');
  writeln (Commit, '; - 0..MAXPLAYERS');
  writeln (Commit, ';');
  writeln (Commit, '; VECTOR');
  writeln (Commit, '; - ~ find an empty one');
  writeln (Commit, '; - 0x60..0x69 specify one');
  writeln (Commit, ';');
  writeln (Commit, '; CONNECTTYPE');
  writeln (Commit, '; - DIALMODE - 0');
  writeln (Commit, '; - ANSWERMODE - 1');
  writeln (Commit, '; - ALREADYCONNECTED - 2');
  writeln (Commit, ';');
  writeln (Commit, 'COMMTYPE = 3');
  writeln (Commit, 'NUMPLAYERS = ', NumPlayers);
  writeln (Commit, 'PAUSE = 0');
  writeln (Commit, 'VECTOR = ~');
  writeln (Commit, 'SOCKETNUMBER = 1');
  writeln (Commit, 'INITSTRING = "ATZ"');
  writeln (Commit, 'HANGUPSTRING = "ATH0=0"');
  writeln (Commit, 'PHONENUMBER = ""');
  writeln (Commit, 'LAUNCHNAME = "DUKE3D.EXE"');
  writeln (Commit, 'CONNECTTYPE = 2');
  writeln (Commit, 'USETONE = 1');
  writeln (Commit, 'COMPORT = 2');
  writeln (Commit, 'IRQNUMBER = ~');
  writeln (Commit, 'UARTADDRESS = ~');
  writeln (Commit, 'PORTSPEED = 9600');
  writeln (Commit, 'SHOWSTATS = 0');
  close (Commit);

END;

{***************************************************************************}
PROCEDURE DefaultControllers
  (VAR NewCFG     : Text;
       Controller : Byte);

BEGIN

  writeln (NewCFG, '[KeyDefinitions]');
  writeln (NewCFG, ';'); 
  writeln (NewCFG, ';');
  writeln (NewCFG, 'Move_Forward = "Up" "Kpad8"');
  writeln (NewCFG, 'Move_Backward = "Down" "Kpad2"');
  writeln (NewCFG, 'Turn_Left = "Left" "Kpad4"');
  writeln (NewCFG, 'Turn_Right = "Right" "KPad6"');
  writeln (NewCFG, 'Strafe = "LAlt" "RAlt"');
  writeln (NewCFG, 'Fire = "LCtrl" "RCtrl"');
  writeln (NewCFG, 'Open = "Space" ""');
  writeln (NewCFG, 'Run = "LShift" "RShift"');
  writeln (NewCFG, 'AutoRun = "CapLck" ""');
  writeln (NewCFG, 'Jump = "A" "/"');
  writeln (NewCFG, 'Crouch = "Z" ""');
  writeln (NewCFG, 'Look_Up = "PgUp" "Kpad9"');
  writeln (NewCFG, 'Look_Down = "PgDn" "Kpad3"');
  writeln (NewCFG, 'Look_Left = "Insert" "Kpad0"');
  writeln (NewCFG, 'Look_Right = "Delete" "Kpad."');
  writeln (NewCFG, 'Strafe_Left = "," ""');
  writeln (NewCFG, 'Strafe_Right = "." ""');
  writeln (NewCFG, 'Aim_Up = "Home" "KPad7"');
  writeln (NewCFG, 'Aim_Down = "End" "Kpad1"');
  writeln (NewCFG, 'Weapon_1 = "1" ""');
  writeln (NewCFG, 'Weapon_2 = "2" ""');
  writeln (NewCFG, 'Weapon_3 = "3" ""');
  writeln (NewCFG, 'Weapon_4 = "4" ""');
  writeln (NewCFG, 'Weapon_5 = "5" ""');
  writeln (NewCFG, 'Weapon_6 = "6" ""');
  writeln (NewCFG, 'Weapon_7 = "7" ""');
  writeln (NewCFG, 'Weapon_8 = "8" ""');
  writeln (NewCFG, 'Weapon_9 = "9" ""');
  writeln (NewCFG, 'Weapon_10 = "0" ""');
  writeln (NewCFG, 'Inventory = "Enter" "KpdEnt"');
  writeln (NewCFG, 'Inventory_Left = "[" ""');
  writeln (NewCFG, 'Inventory_Right = "]" ""');
  writeln (NewCFG, 'Holo_Duke = "H" ""');
  writeln (NewCFG, 'Jetpack = "J" ""');
  writeln (NewCFG, 'NightVision = "N" ""');
  writeln (NewCFG, 'MedKit = "M" ""');
  writeln (NewCFG, 'TurnAround = "BakSpc" ""');
  writeln (NewCFG, 'SendMessage = "T" ""');
  writeln (NewCFG, 'Map = "Tab" ""');
  writeln (NewCFG, 'Shrink_Screen = "-" "Kpad-"');
  writeln (NewCFG, 'Enlarge_Screen = "=" "Kpad+"');
  writeln (NewCFG, 'Center_View = "KPad5" ""');
  writeln (NewCFG, 'Holster_Weapon = "ScrLck" ""');
  writeln (NewCFG, 'Show_Opponents_Weapon = "W" ""');
  writeln (NewCFG, 'Map_Follow_Mode = "F" ""');
  writeln (NewCFG, 'See_Coop_View = "K" ""');
  writeln (NewCFG, 'Mouse_Aiming = "U" ""');
  writeln (NewCFG, 'Toggle_Crosshair = "I" ""');
  writeln (NewCFG, 'Steroids = "R" ""');
  writeln (NewCFG, 'Quick_Kick = "`" ""');
  writeln (NewCFG, 'Next_Weapon = "''" ""');
  writeln (NewCFG, 'Previous_Weapon = ";" ""');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, '[Controls]');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';Controls');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';ControllerType');
  writeln (NewCFG, '; - Keyboard                  - 0');
  writeln (NewCFG, '; - Keyboard and Mouse        - 1');
  writeln (NewCFG, '; - Keyboard and Joystick     - 2');
  writeln (NewCFG, '; - Keyboard and Gamepad      - 4');
  writeln (NewCFG, '; - Keyboard and External     - 3');
  writeln (NewCFG, '; - Keyboard and FlightStick  - 5');
  writeln (NewCFG, '; - Keyboard and ThrustMaster - 6');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  CASE Controller OF
    2 : writeln (NewCFG, 'ControllerType = 0');
    3 : writeln (NewCFG, 'ControllerType = 1');
    4 : writeln (NewCFG, 'ControllerType = 2');
    5 : writeln (NewCFG, 'ControllerType = 4');
    6 : writeln (NewCFG, 'ControllerType = 5');
    7 : writeln (NewCFG, 'ControllerType = 6');
    8 : writeln (NewCFG, 'ControllerType = 3');
  END;
  writeln (NewCFG, 'JoystickPort = 0');
  writeln (NewCFG, 'MouseSensitivity = 32768');
  writeln (NewCFG, 'ExternalFilename = "EXTERNAL.EXE"');
  writeln (NewCFG, 'EnableRudder = 0');
  writeln (NewCFG, 'MouseAiming = 0');
  writeln (NewCFG, 'MouseButton0 = "Fire"');
  writeln (NewCFG, 'MouseButtonClicked0 = ""');
  writeln (NewCFG, 'MouseButton1 = "Strafe"');
  writeln (NewCFG, 'MouseButtonClicked1 = "Open"');
  writeln (NewCFG, 'MouseButton2 = "Move_Forward"');
  writeln (NewCFG, 'MouseButtonClicked2 = ""');
  writeln (NewCFG, 'JoystickButton0 = "Fire"');
  writeln (NewCFG, 'JoystickButtonClicked0 = ""');
  writeln (NewCFG, 'JoystickButton1 = "Strafe"');
  writeln (NewCFG, 'JoystickButtonClicked1 = "Inventory"');
  writeln (NewCFG, 'JoystickButton2 = "Run"');
  writeln (NewCFG, 'JoystickButtonClicked2 = "Jump"');
  writeln (NewCFG, 'JoystickButton3 = "Open"');
  writeln (NewCFG, 'JoystickButtonClicked3 = "Crouch"');
  writeln (NewCFG, 'JoystickButton4 = "Aim_Down"');
  writeln (NewCFG, 'JoystickButtonClicked4 = ""');
  writeln (NewCFG, 'JoystickButton5 = "Look_Right"');
  writeln (NewCFG, 'JoystickButtonClicked5 = ""');
  writeln (NewCFG, 'JoystickButton6 = "Aim_Up"');
  writeln (NewCFG, 'JoystickButtonClicked6 = ""');
  writeln (NewCFG, 'JoystickButton7 = "Look_Left"');
  writeln (NewCFG, 'JoystickButtonClicked7 = ""');
  writeln (NewCFG, 'MouseAnalogAxes0 = "analog_turning"');
  writeln (NewCFG, 'MouseDigitalAxes0_0 = ""');
  writeln (NewCFG, 'MouseDigitalAxes0_1 = ""');
  writeln (NewCFG, 'MouseAnalogScale0 = 65536');
  writeln (NewCFG, 'MouseAnalogAxes1 = "analog_moving"');
  writeln (NewCFG, 'MouseDigitalAxes1_0 = ""');
  writeln (NewCFG, 'MouseDigitalAxes1_1 = ""');
  writeln (NewCFG, 'MouseAnalogScale1 = 65536');
  writeln (NewCFG, 'JoystickAnalogAxes0 = "analog_turning"');
  writeln (NewCFG, 'JoystickDigitalAxes0_0 = ""');
  writeln (NewCFG, 'JoystickDigitalAxes0_1 = ""');
  writeln (NewCFG, 'JoystickAnalogScale0 = 65536');
  writeln (NewCFG, 'JoystickAnalogAxes1 = "analog_moving"');
  writeln (NewCFG, 'JoystickDigitalAxes1_0 = ""');
  writeln (NewCFG, 'JoystickDigitalAxes1_1 = ""');
  writeln (NewCFG, 'JoystickAnalogScale1 = 65536');
  writeln (NewCFG, 'JoystickAnalogAxes2 = "analog_strafing"');
  writeln (NewCFG, 'JoystickDigitalAxes2_0 = ""');
  writeln (NewCFG, 'JoystickDigitalAxes2_1 = ""');
  writeln (NewCFG, 'JoystickAnalogScale2 = 65536');
  writeln (NewCFG, 'JoystickAnalogAxes3 = ""');
  writeln (NewCFG, 'JoystickDigitalAxes3_0 = "Run"');
  writeln (NewCFG, 'JoystickDigitalAxes3_1 = ""');
  writeln (NewCFG, 'JoystickAnalogScale3 = 65536');
  writeln (NewCFG, 'GamePadDigitalAxes0_0 = "Turn_Left"');
  writeln (NewCFG, 'GamePadDigitalAxes0_1 = "Turn_Right"');
  writeln (NewCFG, 'GamePadDigitalAxes1_0 = "Move_Forward"');
  writeln (NewCFG, 'GamePadDigitalAxes1_1 = "Move_Backward"');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');

END;

{***************************************************************************}
PROCEDURE ScreenSettings (VAR NewCFG : Text; VidMode : Byte);

BEGIN

  writeln (NewCFG, '[Setup]');
  writeln (NewCFG, ';Setup File for Duke Nukem 3D');
  writeln (NewCFG, 'SetupVersion = "1.3D"');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, '[Screen Setup]');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';ScreenMode');
  writeln (NewCFG, '; - Chained - 0');
  writeln (NewCFG, '; - Vesa 2.0 - 1');
  writeln (NewCFG, '; - Screen Buffered - 2');
  writeln (NewCFG, '; - Tseng optimized - 3');
  writeln (NewCFG, '; - Paradise optimized - 4');
  writeln (NewCFG, '; - S3 optimized - 5');
  writeln (NewCFG, '; - RedBlue Stereo - 7');
  writeln (NewCFG, '; - Crystal Eyes - 6');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';ScreenWidth passed to engine');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';ScreenHeight passed to engine');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, 'ScreenMode = 1');
  CASE VidMode OF
    1 : writeln (NewCFG, 'ScreenWidth = 320');
    2 : writeln (NewCFG, 'ScreenWidth = 320');
    3 : writeln (NewCFG, 'ScreenWidth = 320');
    4 : writeln (NewCFG, 'ScreenWidth = 360');
    5 : writeln (NewCFG, 'ScreenWidth = 360');
    6 : writeln (NewCFG, 'ScreenWidth = 640');
    7 : writeln (NewCFG, 'ScreenWidth = 640');
    8 : writeln (NewCFG, 'ScreenWidth = 640');
  END;
  CASE VidMode OF
    1 : writeln (NewCFG, 'ScreenHeight = 200');
    2 : writeln (NewCFG, 'ScreenHeight = 240');
    3 : writeln (NewCFG, 'ScreenHeight = 400');
    4 : writeln (NewCFG, 'ScreenHeight = 200');
    5 : writeln (NewCFG, 'ScreenHeight = 240');
    6 : writeln (NewCFG, 'ScreenHeight = 350');
    7 : writeln (NewCFG, 'ScreenHeight = 400');
    8 : writeln (NewCFG, 'ScreenHeight = 480');
  END;
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, 'Shadows = 1');
  writeln (NewCFG, 'Environment = ""');
  writeln (NewCFG, 'Detail = 1');
  writeln (NewCFG, 'Tilt = 1');
  writeln (NewCFG, 'Messages = 1');
  writeln (NewCFG, 'Out = 0');
  writeln (NewCFG, 'ScreenSize = 8');
  writeln (NewCFG, 'ScreenGamma = 23');
  writeln (NewCFG, '[Sound Setup]');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, 'FXDevice = 0');
  writeln (NewCFG, 'MusicDevice = 0');
  writeln (NewCFG, 'FXVolume = 252');
  writeln (NewCFG, 'MusicVolume = 200');
  writeln (NewCFG, 'NumVoices = 4');
  writeln (NewCFG, 'NumChannels = 2');
  writeln (NewCFG, 'NumBits = 16');
  writeln (NewCFG, 'MixRate = 16000');
  writeln (NewCFG, 'MidiPort = 0x300');
  writeln (NewCFG, 'BlasterAddress = 0x220');
  writeln (NewCFG, 'BlasterType = 6');
  writeln (NewCFG, 'BlasterInterrupt = 5');
  writeln (NewCFG, 'BlasterDma8 = 1');
  writeln (NewCFG, 'BlasterDma16 = 5');
  writeln (NewCFG, 'BlasterEmu = 0x620');
  writeln (NewCFG, 'ReverseStereo = 0');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, 'SoundToggle = 1');
  writeln (NewCFG, 'VoiceToggle = 1');
  writeln (NewCFG, 'AmbienceToggle = 1');
  writeln (NewCFG, 'MusicToggle = 0');

END;

{***************************************************************************}
PROCEDURE CommSettings
  (VAR NewCFG : Text;
       PlayerName : String10;
       NumPlayers : Byte);

VAR
  Count : Byte;

BEGIN

  writeln (NewCFG, '[Comm Setup]');
  writeln (NewCFG, ';');
  writeln (NewCFG, ';');
  writeln (NewCFG, 'ComPort = 2');
  writeln (NewCFG, 'IrqNumber = ~');
  writeln (NewCFG, 'UartAddress = ~');
  writeln (NewCFG, 'PortSpeed = 9600');
  writeln (NewCFG, 'ToneDial = 1');
  writeln (NewCFG, 'SocketNumber = 0x1');
  writeln (NewCFG, 'NumberPlayers = ', NumPlayers);
  writeln (NewCFG, 'ModemName = ""');
  writeln (NewCFG, 'InitString = "ATZ"');
  writeln (NewCFG, 'HangupString = "ATH0=0"');
  writeln (NewCFG, 'DialoutString = ""');
  write (NewCFG, 'PlayerName = "');
  FOR Count := 1 TO 10 DO
    write (NewCFG, PlayerName[Count]);
  writeln (NewCFG, '"');
  writeln (NewCFG, 'RTSName = "DUKE.RTS"');
  writeln (NewCFG, 'PhoneNumber = ""');
  writeln (NewCFG, 'ConnectType = 2');
  writeln (NewCFG, 'CommbatMacro#0 = "An inspiration for birth control."');
  writeln (NewCFG, 'CommbatMacro#1 = "You''re gonna die for that!"');
  writeln (NewCFG, 'CommbatMacro#2 = "It hurts to be you."');
  writeln (NewCFG, 'CommbatMacro#3 = "Lucky Son of a Bitch."');
  writeln (NewCFG, 'CommbatMacro#4 = "Hmmm....Payback time."');
  writeln (NewCFG, 'CommbatMacro#5 = "You bottom dwelling scum sucker."');
  writeln (NewCFG, 'CommbatMacro#6 = "Damn, you''re ugly."');
  writeln (NewCFG, 'CommbatMacro#7 = "Ha ha ha...Wasted!"');
  writeln (NewCFG, 'CommbatMacro#8 = "You suck!"');
  writeln (NewCFG, 'CommbatMacro#9 = "AARRRGHHHHH!!!"');
  writeln (NewCFG, 'PhoneName#0 = ""');
  writeln (NewCFG, 'PhoneNumber#0 = ""');
  writeln (NewCFG, 'PhoneName#1 = ""');
  writeln (NewCFG, 'PhoneNumber#1 = ""');
  writeln (NewCFG, 'PhoneName#2 = ""');
  writeln (NewCFG, 'PhoneNumber#2 = ""');
  writeln (NewCFG, 'PhoneName#3 = ""');
  writeln (NewCFG, 'PhoneNumber#3 = ""');
  writeln (NewCFG, 'PhoneName#4 = ""');
  writeln (NewCFG, 'PhoneNumber#4 = ""');
  writeln (NewCFG, 'PhoneName#5 = ""');
  writeln (NewCFG, 'PhoneNumber#5 = ""');
  writeln (NewCFG, 'PhoneName#6 = ""');
  writeln (NewCFG, 'PhoneNumber#6 = ""');
  writeln (NewCFG, 'PhoneName#7 = ""');
  writeln (NewCFG, 'PhoneNumber#7 = ""');
  writeln (NewCFG, 'PhoneName#8 = ""');
  writeln (NewCFG, 'PhoneNumber#8 = ""');
  writeln (NewCFG, 'PhoneName#9 = ""');
  writeln (NewCFG, 'PhoneNumber#9 = ""');
  writeln (NewCFG, '[Misc]');
  writeln (NewCFG, 'Executions = 0');
  writeln (NewCFG, 'RunMode = 1');
  writeln (NewCFG, 'Crosshairs = 1');

END;

{***************************************************************************}

END.